/**
  * Troy Mohl
  * Jesse Perrigo
  * Independent Study - Content Switch
  * 
  * This is the code generation program
  * that will generate code to run on the
  * content switch from an input rule set
  */

/*
 * Rule sets need to be in form of
 * 
 */

#include "RuleTranslate.h"

void ruleTranslate(std::ifstream &infile, std::ofstream &outfile)
{
	char currChar;
	int  currLoc = 0;
	int  ruleNum = 0;
	int  index;
	bool xmlfound = false;
	std::string indexStr;
	std::string ruleNumStr;
	std::string xmlString;
	std::string ruleString;
	std::string inputLine;
	std::string includes;
	std::string endFunctionCalls;
	std::vector <std::string> xmlTags;
	std::vector <std::string> xmlModRules;
	std::vector <std::string> nonXmlRules;

    //setup include string
	includes =  "#include \"extract.h\"\n";
	includes += "#include \"route_to.h\"\n";
	includes += "#include \"stdlib.h\"\n";
	includes += "#include \"string.h\"\n";
	includes += "#include \"url_extract.h\"\n";
	includes += "#include \"ruleTranslate.h\"\n";
	includes += "#define EXIT SUCCESS 0 \n";

	 
	//setup the end of the gen file fcn calls
	endFunctionCalls = "urlextract();";

	std::cout << "Generating output rule file" << std::endl;

	//print a header on gend file
	outfile << "/* Generate output for rule file */" << std::endl;
	outfile << std::endl;

	//print includes and top info
    outfile << includes << std::endl;

	outfile << "/* This program is the main program for doing" << std::endl;
	outfile << "   rule parsing */" << std::endl;
	//outfile << "int ruleMatch (char *url, char *xmlTag);" <<std::endl;
	outfile << "int checkRule ()" << std::endl;
	outfile << "{";

	//parse rule from input file
	std::getline(infile, inputLine);

	while (inputLine.size() > 0 )
	{
		std::cout << "Parsing: " << inputLine << std::endl;
		//init vars
		currLoc = 0;
		ruleString = "";
		xmlString = "";
		xmlfound = false;

		//parse a given rule from rule file
		currChar = inputLine[currLoc];
		while (currChar != ':' && currChar != EOF && currChar != '\n' && 
			   currChar != NULL )
		{
			currLoc++;
			currChar = inputLine[currLoc];
		}//while
		currLoc++;

		//parse to the 'xml.' portion of xml rules
		while (currLoc < inputLine.size())
		{
			if ((inputLine.substr(currLoc, 4)) == "xml.")
			{
				xmlfound = true;

				//move past xml marker
				currLoc+=4;

				//read in xml tag and proc
				currChar = inputLine.at(currLoc);
				while ((currChar >= 'a' && currChar <= 'z') ||
					   (currChar >= 'A' && currChar <= 'Z') ||
					   (currChar == '/'))
				{
					xmlString += currChar;
					currLoc++;
					currChar = inputLine.at(currLoc);
				}

				//finish up rule after xml tag

				//convert int to string
				std::stringstream ss;
				ss << ruleNum;
				ss >> ruleNumStr;

				ruleString += std::string("xmlTag[") + ruleNumStr + "] ";
				ruleString += inputLine.substr(currLoc++,inputLine.size());
				xmlModRules.push_back(ruleString);
				xmlTags.push_back(xmlString);
				ruleNum++;
			}

			//continue havent reached xml tag for processing
			else 
			{
				ruleString += inputLine[currLoc];
			}

			currLoc++;
		}//while

		if (!xmlfound)
			nonXmlRules.push_back(ruleString);

		//get next line
		std::getline(infile, inputLine);
	}//while

	// add 'return' to end of rule strings
	// non xml
	for (index = 0; index < nonXmlRules.size(); index++)
	{
		indexStr = nonXmlRules.at(index);
		indexStr = indexStr.substr(0, (indexStr.find_last_of("}")-1));
		indexStr += " return 0; }";
		nonXmlRules.at(index) = indexStr;
	}

	// xml
	for (index = 0; index < xmlModRules.size(); index++)
	{
		indexStr = xmlModRules.at(index);
		indexStr = indexStr.substr(0, (indexStr.find_last_of("}")-1));
		indexStr += " return 0; }";
		xmlModRules.at(index) = indexStr;		
	}

    //print out xml tag array
	outfile << std::endl;
	outfile << "int temp;" << std::endl;
	outfile << "char url[1000];" << std::endl;
	outfile << "/* XML Tag array */" <<std::endl;
	outfile << "char *xmlTagSequence[" << xmlTags.size() << "];" << std::endl;
	outfile << "int numOfXmlTagSequences" << std::endl;
	outfile << "/* value array for putting in extracted xml vals */" << std::endl;
	outfile << "char *xmlTagValue [" << xmlTags.size() << "];" << std::endl;
	outfile << std::endl;
		
	for (index = 0; index < xmlTags.size(); index++)
	{
		outfile << "xmlTagSequence[" << index << "] = \"" 
				<< xmlTags.at(index) << "\";" << std::endl;
	}
	outfile << std::endl;

	std::stringstream ss;
	ss << xmlTags.size();
	ss >> indexStr;
	outfile << "/* Number of tags in above array */" << std::endl;
    outfile << "numOfXmlTagSequences = " + indexStr+";" << std::endl;
    outfile << std::endl;

	//xml extract call 
	outfile << endFunctionCalls << std::endl;
	outfile << "xmlExtract(packet, xmlTagSequence, numOfXmlTagSequences, xmlTagValue);" <<std::endl;
	outfile << "int temp = ruleMatch (url, xmlTagSequence);" << std::endl;
	outfile << std::endl;

	//end of main stuff
	outfile << "return EXIT_SUCCESS;" << std::endl;
	outfile << "}" << std::endl;

	//print rule check fcn
	outfile << std::endl << std::endl;
	outfile << "/* Check the rules */" << std::endl;
	outfile << "int ruleMatch(char *url, char *xmlTag[])" << std::endl;
	outfile << "{" << std::endl << std::endl;

	//print out the rules, nonxml and xml
	//non xml rules
	for (index = 0; index < nonXmlRules.size(); index++)
	{
		//convert int to str
		std::stringstream ss;
		ss << index;
		ss >> indexStr;

		outfile << std::string("/* Non-xml Rule: ") + indexStr + " */" << std::endl;
		outfile << nonXmlRules.at(index) << std::endl;
	}//for

	outfile << std::endl << std::endl;
	//xml rules
	for (index = 0; index < xmlModRules.size(); index++)
	{
		//convert int to str
		std::stringstream ss;
		ss << index;
		ss >> indexStr;
		outfile << std::string("/* Xml Rule: ") + indexStr + " */" << std::endl;
		outfile << xmlModRules.at(index) << std::endl; 
	}//for

	std::cout << "finished" << std::endl;

	//print bottom of ruleMatch
	outfile << "}" << std::endl;
	
    //end of file stuff
	outfile << std::endl;
	outfile << "/* End of Generated File */";
}//ruleTranslate


int main(int argc, char **args)
{	
	//file names
	std::string inFileName;
	std::string outFileName;
	//file streams
	std::ifstream infile;
	std::ofstream outfile;

	if (argc == 3)
	{
		inFileName = args[1];
		outFileName = args[2];
		infile.open(inFileName.c_str());
		outfile.open(outFileName.c_str());
	}
	else
	{
		std::cout << "To use command line: ruletranslate inputFile outputFile" << std::endl;
		std::cout << std::endl;
		std::cout << "Please type in input file: ";
		std::cin >> inFileName;
		infile.open(inFileName.c_str());

		std::cout << "Please type in output file: ";
		std::cin >> outFileName;
		outfile.open(outFileName.c_str());
	}

	// loop while unable to open input file
	while (!infile)
	{
		infile.close();
		infile.clear();
		std::cout << "ERROR: Unable to open infile: " << inFileName << std::endl;
		std::cout << "Enter input file name: ";
		std::cin >> inFileName;
		infile.open(inFileName.c_str());
	}//while

	//setup output file stream
	while (!outfile)
	{
		outfile.close();
		outfile.clear();
		std::cout << "ERROR: Unable to open outfile: " << inFileName << std::endl;
		std::cout << "Enter output file name: ";
		std::cin >> outFileName;
		outfile.open(outFileName.c_str());
	}

	ruleTranslate(infile, outfile);

	return EXIT_SUCCESS;
}//main





